From: =?utf-8?q?Guido_G=C3=BCnther?= <agx@sigxcpu.org>
Date: Sat, 14 Nov 2020 20:20:48 +0100
Subject: drm: cadence/mhdp: Add runtime pm stubs
MIME-Version: 1.0
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: 8bit

This does nothing except for adding the hooks at the right places.

Signed-off-by: Guido Günther <guido.gunther@puri.sm>
---
 drivers/gpu/drm/bridge/cadence/cdns-dp-core.c | 36 +++++++++++++++++++++++++++
 drivers/gpu/drm/imx/mhdp/cdns-mhdp-imxdrv.c   | 33 ++++++++++++++++++++++++
 include/drm/bridge/cdns-mhdp.h                |  5 ++++
 3 files changed, 74 insertions(+)

diff --git a/drivers/gpu/drm/bridge/cadence/cdns-dp-core.c b/drivers/gpu/drm/bridge/cadence/cdns-dp-core.c
index f2c0822..cc39f0e 100644
--- a/drivers/gpu/drm/bridge/cadence/cdns-dp-core.c
+++ b/drivers/gpu/drm/bridge/cadence/cdns-dp-core.c
@@ -20,6 +20,7 @@
 #include <linux/module.h>
 #include <linux/mutex.h>
 #include <linux/of_device.h>
+#include <linux/pm_runtime.h>
 
 #include "cdns-mhdp-common.h"
 
@@ -197,6 +198,8 @@ static int cdns_dp_connector_get_modes(struct drm_connector *connector)
 	int num_modes = 0;
 	struct edid *edid;
 
+	pm_runtime_get_sync(mhdp->dev);
+
 	edid = drm_do_get_edid(&mhdp->connector.base,
 				   cdns_mhdp_get_edid_block, mhdp);
 	if (edid) {
@@ -212,6 +215,9 @@ static int cdns_dp_connector_get_modes(struct drm_connector *connector)
 
 	if (num_modes == 0)
 		DRM_ERROR("Invalid edid\n");
+
+	pm_runtime_put(mhdp->dev);
+
 	return num_modes;
 }
 
@@ -312,6 +318,8 @@ static void cdn_dp_bridge_enable(struct drm_bridge *bridge)
 	struct cdns_mhdp_device *mhdp = bridge->driver_private;
 	int ret;
 
+	pm_runtime_get_sync(mhdp->dev);
+
 	/* Link trainning */
 	ret = cdns_mhdp_train_link(mhdp);
 	if (ret) {
@@ -331,6 +339,8 @@ static void cdn_dp_bridge_disable(struct drm_bridge *bridge)
 	struct cdns_mhdp_device *mhdp = bridge->driver_private;
 
 	cdns_mhdp_set_video_status(mhdp, CONTROL_VIDEO_IDLE);
+
+	pm_runtime_put(mhdp->dev);
 }
 
 static const struct drm_bridge_funcs cdns_dp_bridge_funcs = {
@@ -459,6 +469,13 @@ static int __cdns_dp_probe(struct platform_device *pdev,
 
 	dp_aux_init(mhdp, dev);
 
+	pm_runtime_set_active(dev);
+	pm_runtime_mark_last_busy(dev);
+	pm_runtime_enable(dev);
+	pm_runtime_set_autosuspend_delay(dev, 500);
+	pm_runtime_use_autosuspend(dev);
+
+
 	return 0;
 }
 
@@ -466,6 +483,7 @@ static void __cdns_dp_remove(struct cdns_mhdp_device *mhdp)
 {
 	dp_aux_destroy(mhdp);
 	cdns_mhdp_unregister_audio_driver(mhdp->dev);
+	pm_runtime_disable(mhdp->dev);
 }
 
 /* -----------------------------------------------------------------------------
@@ -527,6 +545,24 @@ void cdns_dp_unbind(struct device *dev)
 }
 EXPORT_SYMBOL_GPL(cdns_dp_unbind);
 
+/* Runtime suspend */
+
+int cdns_dp_pm_runtime_suspend(struct cdns_mhdp_device *mhdp)
+{
+	dev_dbg(mhdp->dev, "Runtime suspend");
+
+	return 0;
+}
+EXPORT_SYMBOL_GPL(cdns_dp_pm_runtime_suspend);
+
+int cdns_dp_pm_runtime_resume(struct cdns_mhdp_device *mhdp)
+{
+	dev_dbg(mhdp->dev, "Runtime resume");
+
+	return 0;
+}
+EXPORT_SYMBOL_GPL(cdns_dp_pm_runtime_resume);
+
 MODULE_AUTHOR("Sandor Yu <sandor.yu@nxp.com>");
 MODULE_DESCRIPTION("Cadence Display Port transmitter driver");
 MODULE_LICENSE("GPL");
diff --git a/drivers/gpu/drm/imx/mhdp/cdns-mhdp-imxdrv.c b/drivers/gpu/drm/imx/mhdp/cdns-mhdp-imxdrv.c
index 607d0b3..b691206 100644
--- a/drivers/gpu/drm/imx/mhdp/cdns-mhdp-imxdrv.c
+++ b/drivers/gpu/drm/imx/mhdp/cdns-mhdp-imxdrv.c
@@ -38,6 +38,8 @@ static struct cdns_plat_data imx8mq_dp_drv_data = {
 	.unbind	= cdns_dp_unbind,
 	.phy_set = cdns_dp_phy_set_imx8mq,
 	.lane_mapping = 0xc6,
+	.pm_runtime_suspend = cdns_dp_pm_runtime_suspend,
+	.pm_runtime_resume = cdns_dp_pm_runtime_resume,
 };
 
 static const struct of_device_id cdns_mhdp_imx_dt_ids[] = {
@@ -126,13 +128,44 @@ static int cdns_mhdp_imx_remove(struct platform_device *pdev)
 	return 0;
 }
 
+static int __maybe_unused cdns_mhdp_imx_resume(struct device *dev)
+{
+	struct imx_mhdp_device *imx_mhdp = dev_get_drvdata(dev);
+	int ret = 0;
+
+	if (imx_mhdp->mhdp.plat_data->pm_runtime_resume)
+		imx_mhdp->mhdp.plat_data->pm_runtime_resume(&imx_mhdp->mhdp);
+
+	return ret;
+}
+
+static int __maybe_unused cdns_mhdp_imx_suspend(struct device *dev)
+{
+	struct imx_mhdp_device *imx_mhdp = dev_get_drvdata(dev);
+	int ret = 0;
+
+	if (imx_mhdp->mhdp.plat_data->pm_runtime_suspend)
+		imx_mhdp->mhdp.plat_data->pm_runtime_suspend(&imx_mhdp->mhdp);
+
+	return ret;
+}
+
+static const struct dev_pm_ops cdns_mhdp_imx_pm_ops = {
+	SET_RUNTIME_PM_OPS(cdns_mhdp_imx_suspend,
+			   cdns_mhdp_imx_resume,
+			   NULL)
+};
+
+
 static struct platform_driver cdns_mhdp_imx_platform_driver = {
 	.probe  = cdns_mhdp_imx_probe,
 	.remove = cdns_mhdp_imx_remove,
 	.driver = {
 		.name = "cdns-mhdp-imx",
 		.of_match_table = cdns_mhdp_imx_dt_ids,
+		.pm = &cdns_mhdp_imx_pm_ops,
 	},
+
 };
 
 module_platform_driver(cdns_mhdp_imx_platform_driver);
diff --git a/include/drm/bridge/cdns-mhdp.h b/include/drm/bridge/cdns-mhdp.h
index 2075c88..5ea343b 100644
--- a/include/drm/bridge/cdns-mhdp.h
+++ b/include/drm/bridge/cdns-mhdp.h
@@ -592,6 +592,9 @@ struct cdns_plat_data {
 	int (*power_on)(struct cdns_mhdp_device *mhdp);
 	int (*power_off)(struct cdns_mhdp_device *mhdp);
 
+	int (*pm_runtime_suspend)(struct cdns_mhdp_device *mhdp);
+	int (*pm_runtime_resume)(struct cdns_mhdp_device *mhdp);
+
 	char *plat_name;
 	int lane_mapping;
 };
@@ -666,6 +669,8 @@ u32 cdns_phy_reg_read(struct cdns_mhdp_device *mhdp, u32 addr);
 int cdns_dp_bind(struct platform_device *pdev, struct drm_encoder *encoder,
 		struct cdns_mhdp_device *mhdp);
 void cdns_dp_unbind(struct device *dev);
+int cdns_dp_pm_runtime_suspend(struct cdns_mhdp_device *pdev);
+int cdns_dp_pm_runtime_resume(struct cdns_mhdp_device *pdev);
 
 /* HDMI */
 int cdns_hdmi_bind(struct platform_device *pdev, struct drm_encoder *encoder,
